#
# spec file for package apache2-mod_qos
#
# Copyright (c) 2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           apache2-mod_qos
Version:        11.45
Release:        1.8
Summary:        Quality of Sevice Module for the Apache Web Server
License:        GPL-2.0
Group:          Productivity/Networking/Web/Servers
Url:            http://mod-qos.sourceforge.net/
Source:         http://downloads.sourceforge.net/project/mod-qos/mod_qos-%{version}.tar.gz
Patch1:         mod_qos-loggerThread.patch
BuildRequires:  apache2-devel
BuildRequires:  apache2-worker
BuildRequires:  apache-rpm-macros
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gcc
BuildRequires:  glibc-devel
BuildRequires:  apr-util-devel
BuildRequires:  apr-devel
BuildRequires:  libpng-devel
BuildRequires:  make
BuildRequires:  openldap2-devel
BuildRequires:  openssl-devel
BuildRequires:  pcre-devel
BuildRequires:  pkgconfig
Requires:       %{apache_mmn}
Requires:       %{apache_suse_maintenance_mmn}
Requires:       apache2
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
mod_qos is a quality of service module for the Apache Web Server. It implements
control mechanisms that can provide different priority to different requests
and controls server access based on available resources.

mod_qos may be used to determine which requests should be served and which
shouldn't in order to avoid resource oversubscription. The module collects
different attributes such as the request URL, HTTP request and response
headers, the IP source address, the HTTP response code, history data (user
session and on per source IP address basis), the number of concurrent requests
to the server (total or requests having similar attributes), the number of
concurrent TCP connections (total or from a single source IP), and so forth.

%prep
%setup -q -n "mod_qos-%{version}"
%patch1
find . -type f -exec sed -i 's/\r$//' {} \;

%build
pushd apache2
# see: doc/index.html
# " mod_qos has been developed and fully
#   tested for Apache version 2.2 MPM worker binaries"
%{apache_apxs}-worker -c mod_qos.c
popd
pushd tools
autoreconf -fiv
%configure --bindir=%{_sbindir}
make
popd

%install
mkdir -p %{buildroot}/%{apache_libexecdir}-worker
mkdir -p %{buildroot}/%{apache_localstatedir}/mod_qos
pushd apache2
install -m 755 .libs/mod_qos.so %{buildroot}/%{apache_libexecdir}-worker
popd
pushd tools
make DESTDIR=%{buildroot} install
popd

%check
set +x
%apache_test_module_load -m ssl:qos -t worker
set -x

%files
%defattr(-,root,root)
%{apache_libexecdir}-worker/mod_qos.so
%{_sbindir}/*
%attr(0750,wwwrun,root) %{apache_localstatedir}/mod_qos
%doc README.TXT
%doc doc/*

%changelog
* Wed Dec 20 2017 pgajdos@suse.com
- update to 11.45
* Tue Dec 19 2017 pgajdos@suse.com
- buildrequire apr-util-devel instead of libapr-util1-devel
- buildrequire apr-devel instead of libapr1-devel
* Wed Sep 30 2015 pgajdos@suse.com
- test module again
* Wed Sep 30 2015 pgajdos@suse.com
- update to 11.17
- build only for worker mpm
* Mon Sep  7 2015 pgajdos@suse.com
- test module with %%apache_test_module_load
* Thu Jul 16 2015 pgajdos@suse.com
- Requries: %%{apache_suse_maintenance_mmn}
  This will pull this module to the update (in released distribution)
  when apache maintainer thinks it is good (due api/abi changes).
* Thu Jun  4 2015 pgajdos@suse.com
- drop mod_qos.conf as it seems to be outdated (see documentation
  for use case examples)
* Tue Jun  2 2015 pgajdos@suse.com
- configuration uses old syntax only when access_compat is loaded
* Tue Nov  4 2014 pgajdos@suse.com
- call spec-cleaner
- use apache rpm macros
- update to 11.5
  * fixes build
  * see CHANGES.TXT for upstream change log
* Sat Mar  5 2011 draht@suse.de
- mod_qos-loggerThread.patch:
  incorrect use of pthread_create(), use usleep() instead of sleep()
* Sat Mar  5 2011 draht@suse.de
- openssl-1.* changes struct STACK to _STACK; spec file adopted
  for 11.3+.
* Fri Sep 25 2009 crrodriguez@suse.de
- Requires: apache2 %%{apache_mmn}
